<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-field.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-filter.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="shared-styles.html">

<dom-module id="deployments-list">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        background: transparent;
      }
      vaadin-grid-filter {
        width: 100%;
      }
      vaadin-text-field {
        width: 100%;
      }
    </style>

    <brum-global-variable key="apiBase" value="{{apiBase}}" readonly></brum-global-variable>
    <brum-global-variable key="backendBase" value="{{backendBase}}" readonly></brum-global-variable>
    <brum-global-variable key="teamAuth" value="{{teamAuth}}" readonly></brum-global-variable>

    <iron-ajax with-credentials auto url="[[apiBase]]/deployments" last-response="{{deployments}}"></iron-ajax>

    <div class="card">
      <vaadin-grid items="[[deployments.result]]">
        <vaadin-grid-column>
          <template class="header">Date</template>
          <template>[[item.date]]</template>
        </vaadin-grid-column>

        <template is="dom-if" if="[[!teamAuth]]">
          <vaadin-grid-column>
            <template class="header">
              <vaadin-grid-filter path="team" value="[[_filterTeam]]">
                <vaadin-text-field slot="filter" placeholder="Team" value="{{_filterTeam}}"
                                   focus-target></vaadin-text-field>
              </vaadin-grid-filter>
            </template>
            <template>[[item.team]]</template>
          </vaadin-grid-column>
        </template>
        <template is="dom-if" if="[[teamAuth]]">
          <vaadin-grid-column>
            <template class="header">
              <vaadin-grid-filter path="user" value="[[_filterUser]]">
                <vaadin-text-field slot="filter" placeholder="User" value="{{_filterUser}}"
                                   focus-target></vaadin-text-field>
              </vaadin-grid-filter>
            </template>
            <template>[[item.user]]</template>
          </vaadin-grid-column>
        </template>

        <vaadin-grid-column>
          <template class="header">Status</template>
          <template>[[item.status]]</template>
        </vaadin-grid-column>

        <template is="dom-if" if="[[teamAuth]]">
          <vaadin-grid-column>
            <template class="header">ID</template>
            <template>
              <a>[[_formatImageId(item.imageId)]]</a>
            </template>
          </vaadin-grid-column>
        </template>
      </vaadin-grid>
    </div>
  </template>
  <script>
    class DeploymentsList extends Polymer.Element {
      static get is() {
        return 'deployments-list';
      }

      // noinspection JSUnusedGlobalSymbols
      static get properties() {
        return {
          _filterTeam: {
            type: String,
            value: '',
          },
          _filterUser: {
            type: String,
            value: '',
          },
        };
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSMethodCanBeStatic
      _formatImageId(imageId) {
        try {
          return imageId.match(/^(?:[a-z0-9]+:)?([a-z0-9]{12})/)[1];
        } catch (e) {
          return imageId;
        }
      }
    }

    window.customElements.define(DeploymentsList.is, DeploymentsList);
  </script>
</dom-module>
